using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Drawing;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace DeleteDataGridRowIssue
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl _gridNoteSearch;
		private Syncfusion.Windows.Forms.ButtonAdv btnDeleteCriteria;
		private bool _gridInitialized = false;
		private Hashtable _deleteNoteSearchList = new Hashtable();
		Criteria _criteriaSelectedOnGrid = null;
		private CriteriaList _criteriaList = new CriteriaList();
		private Criterias _criterias = new Criterias();

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			_criterias = CreateCriterias();
			BindData(_criterias);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this._gridNoteSearch = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.btnDeleteCriteria = new Syncfusion.Windows.Forms.ButtonAdv();
			((System.ComponentModel.ISupportInitialize)(this._gridNoteSearch)).BeginInit();
			this.SuspendLayout();
			// 
			// _gridNoteSearch
			// 
			this._gridNoteSearch.BackColor = System.Drawing.SystemColors.Window;
			this._gridNoteSearch.ChildGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this._gridNoteSearch.Location = new System.Drawing.Point(16, 16);
			this._gridNoteSearch.Name = "_gridNoteSearch";
			this._gridNoteSearch.ShowNestedPropertiesFields = false;
			this._gridNoteSearch.Size = new System.Drawing.Size(724, 150);
			this._gridNoteSearch.TabIndex = 11;
			this._gridNoteSearch.Text = "gridGroupingControl1";
			this._gridNoteSearch.VersionInfo = "4.101.0.50";
			// 
			// btnDeleteCriteria
			// 
			this.btnDeleteCriteria.Appearance = Syncfusion.Windows.Forms.ButtonAppearance.WindowsXP;
			this.btnDeleteCriteria.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(203)), ((System.Byte)(221)), ((System.Byte)(246)));
			this.btnDeleteCriteria.BorderStyleAdv = Syncfusion.Windows.Forms.ButtonAdvBorderStyle.Solid;
			this.btnDeleteCriteria.ComboEditBackColor = System.Drawing.Color.Empty;
			this.btnDeleteCriteria.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnDeleteCriteria.IsMouseDown = false;
			this.btnDeleteCriteria.Location = new System.Drawing.Point(664, 184);
			this.btnDeleteCriteria.Name = "btnDeleteCriteria";
			this.btnDeleteCriteria.TabIndex = 13;
			this.btnDeleteCriteria.Text = "De&lete";
			this.btnDeleteCriteria.UseVisualStyle = true;
			this.btnDeleteCriteria.Click += new System.EventHandler(this.btnDeleteCriteria_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(752, 222);
			this.Controls.Add(this.btnDeleteCriteria);
			this.Controls.Add(this._gridNoteSearch);
			this.Name = "Form1";
			this.Text = "Main";
			((System.ComponentModel.ISupportInitialize)(this._gridNoteSearch)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void InitializeNoteSearchGrid()
		{
			try
			{
				if(_gridInitialized) {return;}

				this._gridNoteSearch.BeginUpdate();

				this._gridNoteSearch.TableControl.Selections.Clear();
				this._gridNoteSearch.TableOptions.AllowSelection = GridSelectionFlags.None; // For Bulk insert
 
				this._gridNoteSearch.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One; // For Bulk insert
				
				//Set the color of the Alternate Records 
				this._gridNoteSearch.Appearance.AlternateRecordFieldCell.BackColor = Color.FromArgb(223, 223, 223); 
				this._gridNoteSearch.Appearance.RecordFieldCell.BackColor = Color.WhiteSmoke;
				
				this._gridNoteSearch.TableDescriptor.TableOptions.SelectionBackColor = Color.RoyalBlue;
				
				this._gridNoteSearch.Appearance.ColumnHeaderCell.Font.Bold = true;


				this._gridNoteSearch.TableDescriptor.AllowNew = false; // For Bulk insert
				this._gridNoteSearch.TableDescriptor.AllowEdit = true;// For Bulk insert
				this._gridNoteSearch.TableDescriptor.AllowRemove = false;// For Bulk insert
				
				for(int i=0;i < this._gridNoteSearch.TableDescriptor.Columns.Count;i++)
				{
					this._gridNoteSearch.TableDescriptor.VisibleColumns.Remove(this._gridNoteSearch.TableDescriptor.Columns[i].Name);
				}

				this._gridNoteSearch.TableDescriptor.UnboundFields.Add("Delete");
				this._gridNoteSearch.TableDescriptor.Columns["Delete"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
				this._gridNoteSearch.TableDescriptor.Columns["Delete"].FieldDescriptor.ReadOnly = false;
				this._gridNoteSearch.TableDescriptor.Columns["Delete"].Appearance.AnyRecordFieldCell.HorizontalAlignment = GridHorizontalAlignment.Center;

				this._gridNoteSearch.TableDescriptor.VisibleColumns.Add("Name");
				this._gridNoteSearch.TableDescriptor.VisibleColumns.Add("SelectedOperator");
				this._gridNoteSearch.TableDescriptor.VisibleColumns.Add("Value");
				this._gridNoteSearch.TableDescriptor.VisibleColumns.Add("Delete");


				this._gridNoteSearch.TableDescriptor.Columns["Name"].Width = 200;
				this._gridNoteSearch.TableDescriptor.Columns["Name"].FieldDescriptor.ReadOnly = true;
				this._gridNoteSearch.TableDescriptor.Columns["Name"].HeaderText = "Field";

				this._gridNoteSearch.TableDescriptor.Columns["SelectedOperator"].Width = 200;
				this._gridNoteSearch.TableDescriptor.Columns["SelectedOperator"].HeaderText ="Operator";
				this._gridNoteSearch.TableDescriptor.Columns["SelectedOperator"].FieldDescriptor.ReadOnly =true; 
				//this._gridNoteSearch.TableDescriptor.Columns["SelectedOperator"].Appearance.AnyRecordFieldCell.CellType = "Text";

				this._gridNoteSearch.TableDescriptor.Columns["Value"].Width = 200;
				this._gridNoteSearch.TableDescriptor.Columns["Value"].FieldDescriptor.ReadOnly = true;
				this._gridNoteSearch.TableDescriptor.Columns["Value"].HeaderText = "Value";

				this._gridNoteSearch.TableDescriptor.Columns["Delete"].Width = 80;

				this._gridNoteSearch.TableDescriptor.VisibleColumns[0].Name="Name";
				this._gridNoteSearch.TableDescriptor.VisibleColumns[1].Name="SelectedOperator";
				this._gridNoteSearch.TableDescriptor.VisibleColumns[2].Name="Value";
				this._gridNoteSearch.TableDescriptor.VisibleColumns[3].Name="Delete";

				this._gridNoteSearch.TableControlCellDoubleClick += new GridTableControlCellClickEventHandler(_gridNoteSearch_TableControlCellDoubleClick);
				this._gridNoteSearch.TableModel.Options.ActivateCurrentCellBehavior = GridCellActivateAction.None;
				this._gridNoteSearch.SelectedRecordsChanged +=new SelectedRecordsChangedEventHandler(_gridNoteSearch_SelectedRecordsChanged);
				this._gridNoteSearch.TableDescriptor.QueryValue += new FieldValueEventHandler(Model_QueryCellInfo);
				this._gridNoteSearch.TableDescriptor.SaveValue += new FieldValueEventHandler(Model_SaveCellInfo);

				this._gridNoteSearch.EndUpdate(true);
				_gridInitialized = true;
			}
			catch(Exception ex)
			{
				throw new Exception("Unable to initialize grid.", ex);
			}
		}

		private void Model_QueryCellInfo(object sender, FieldValueEventArgs e)
		{
		
			if(e.Record == null) {return;}
			int Id = Int32.Parse(e.Record.GetValue("Id").ToString());
			if (e.Field.Name == "Delete" && Id >=0)
			{
				object value = _deleteNoteSearchList[Id];
				if (value != null)
					e.Value= value;
			}
		}

		private void Model_SaveCellInfo(object sender, FieldValueEventArgs e)
		{
			if(e.Record == null) {return;}
			int Id = Int32.Parse(e.Record.GetValue("Id").ToString());

			if (e.Field.Name == "Delete" && Id>=0)
			{
				_deleteNoteSearchList[Id] = e.Value;
			}
		}
		private void _gridNoteSearch_TableControlCellDoubleClick(object sender, GridTableControlCellClickEventArgs e)
		{
			GridCurrentCell cc = e.TableControl.CurrentCell;
			GridTableCellStyleInfo style = e.TableControl.Model[cc.RowIndex, cc.ColIndex];

			if(style.TableCellIdentity.DisplayElement.ParentRecord != null)
			{
				//MySNController.Show("DynamicNoteSearchDetailForm");
				frmDetail dtl = new frmDetail(_criteriaSelectedOnGrid);
				dtl.ShowDialog();
			}
        
		}

		/// <summary>
		/// Assign selected row into the global cache
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void _gridNoteSearch_SelectedRecordsChanged(object sender, SelectedRecordsChangedEventArgs e)
		{
			if(e.SelectedRecord != null && e.Action == SelectedRecordsChangedType.Added)
			{
				_criteriaSelectedOnGrid = (Criteria) _criteriaList[_criteriaList.IndexOfCriteriaId(Int32.Parse(e.SelectedRecord.Record.GetValue("Id").ToString()))].Clone();
				//MySNController.SelectedCriteria = _criteriaSelectedOnGrid;
			}
		}

		/// <summary>
		/// In actual scenario this will come from database
		/// </summary>
		/// <returns></returns>
		private Criterias CreateCriterias()
		{
			Criterias criterias = new Criterias();
			Criteria criteria1, criteria2, criteria3, criteria4, criteria5  ;

			criteria1 = new Criteria();
			criteria1.Id = 1;
			criteria1.Name = "FOS_ID";
			criteria1.DBType = "string";
			criteria1.SelectedOperator = "!=";
			criteria1.Value = "0";

			criteria2 = new Criteria();
			criteria2.Id = 2;
			criteria2.Name = "RISKCLASS";
			criteria2.DBType = "string";
			criteria2.SelectedOperator = "=";
			criteria2.Value = "IRNG";

			criteria3 = new Criteria();
			criteria3.Id = 3;
			criteria3.Name = "VERSION_FROM_DT";
			criteria3.DBType = "date";
			criteria3.SelectedOperator = "=";
			criteria3.Value = "06-JUL-2006";

			criteria4 = new Criteria();
			criteria4.Id = 4;
			criteria4.Name = "VERSION_TO_DT";
			criteria4.DBType = "date";
			criteria4.SelectedOperator = "=";
			criteria4.Value = "31-DEC-9999";

			criteria5 = new Criteria();
			criteria5.Id = 5;
			criteria5.Name = "VALOREN";
			criteria5.DBType = "number";
			criteria5.SelectedOperator = ">";
			criteria5.Value = "0";

			criterias.CriteriaList.Add(criteria1);
			criterias.CriteriaList.Add(criteria2);
			criterias.CriteriaList.Add(criteria3);
			criterias.CriteriaList.Add(criteria4);
			criterias.CriteriaList.Add(criteria5);
			return criterias;
		}

		private void BindData(Criterias crs)
		{
			int selectedRow = -1;
			int id = 0;
			_gridNoteSearch.BeginUpdate();
			_gridNoteSearch.DataBindings.Clear();
			_gridNoteSearch.DataSource = null;
			_gridNoteSearch.Refresh();
			_deleteNoteSearchList.Clear();
			_criteriaList = crs.CriteriaList;
			_gridNoteSearch.DataSource = _criteriaList;
			_gridNoteSearch.Refresh();
			InitializeNoteSearchGrid();
			///Default to previous selected row if any
			if(_criteriaSelectedOnGrid != null)
			{
				for(int index = 0; index < this._gridNoteSearch.Table.Records.Count; index++)
				{
					id = Int32.Parse(this._gridNoteSearch.Table.Records[index].GetValue("Id").ToString());
					if(id == _criteriaSelectedOnGrid.Id)
					{
						selectedRow = index;
						break;
					}
				}
			}
			if(selectedRow < 0 && _gridNoteSearch.Table.Records.Count > 0 )
			{
				selectedRow = 0;
			}

			//if(_gridObsTrade.Table.Records.Count > 0)
			if(selectedRow >= 0)
			{
				this._gridNoteSearch.Table.SelectedRecords.Clear();
				this._gridNoteSearch.Table.SelectedRecords.Add(_gridNoteSearch.Table.Records[selectedRow]);
			}
			
			_gridNoteSearch.EndUpdate(true);
		}

		private void btnDeleteCriteria_Click(object sender, System.EventArgs e)
		{
			int[] criteriaSelectedForDeletion = null;
			int counter = 0;
			
			IDictionaryEnumerator enumerator = _deleteNoteSearchList.GetEnumerator();
			while ( enumerator.MoveNext() )
			{
				if(enumerator.Value.ToString().ToLower() == "false") 
				{
					_deleteNoteSearchList.Remove(enumerator.Key);
					enumerator = _deleteNoteSearchList.GetEnumerator();
					continue;
				}
			}

			if(_deleteNoteSearchList.Keys.Count > 0)
			{
				criteriaSelectedForDeletion = new int[_deleteNoteSearchList.Keys.Count];
				
				enumerator = _deleteNoteSearchList.GetEnumerator();
				while ( enumerator.MoveNext() )
				{
					criteriaSelectedForDeletion[counter++] = Int32.Parse(enumerator.Key.ToString());
				}

				BulkDeleteCriteria(criteriaSelectedForDeletion);
			}
		}

		public void BulkDeleteCriteria(int[] criteriaSelectedForDeletion)
		{
			try
			{
				if(criteriaSelectedForDeletion.Length > 0)
				{
					for(int index=0; index < criteriaSelectedForDeletion.Length; index++)
					{
						_criteriaList.RemoveAt(_criteriaList.IndexOfCriteriaId(criteriaSelectedForDeletion[index]));
					}
					BindData(_criterias.Clone() as Criterias);
				}
				
			}
			catch(Exception ex)
			{
				throw new Exception("Deleting Search Criteria(s) failed.",ex);
				//ShowError();
			}
		}
	}
}
